/*
 * Triangle.java
 *
 * Created on 2. Mrz 2007, 13:16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Engine.Primitives;

import Engine.*;
import java.awt.Graphics;
import java.awt.Point;

/**
 *
 * @author Sunshine
 */
public class Triangle implements PrimitiveInterface {
    
    public Vector3D vertices[];
    public Vector3D worldPos;
    
    
    /** Creates a new instance of Triangle */
    public Triangle(Vector3D triangle[]) {
       vertices = new Vector3D[3];
       if (triangle.length != 3) return;
       vertices[0] = triangle[0];
       vertices[1] = triangle[1];
       vertices[2] = triangle[2];
       worldPos = new Vector3D(-10,0, 80);
    }
    
    public Triangle(Vector3D v0, Vector3D v1, Vector3D v2)
    {
        vertices = new Vector3D[3];
        vertices[0] = v0;
        vertices[1] = v1;
        vertices[2] = v2;
        worldPos = new Vector3D(-10,0, 80);
    }

    /*
     * Render triangle
     */
    public void render(Graphics g, Point[] screenCoords) 
    {   
       g.drawLine(screenCoords[0].x, screenCoords[0].y,
                  screenCoords[1].x, screenCoords[1].y);
       g.drawLine(screenCoords[1].x, screenCoords[1].y,
                  screenCoords[2].x, screenCoords[2].y);
       g.drawLine(screenCoords[2].x, screenCoords[2].y,
                  screenCoords[0].x, screenCoords[0].y);
    }
    
     public int getNumOfVertices() { return 3; }
     public Vector3D[] getVertices() { return vertices; }
     public Vector3D getWorldPos() { return worldPos; }
    
     public void rotY(double angle) {
         for (int i = 0; i < 3; i++)
             vertices[i].rotY(angle);
     }
     public void rotX(double angle) {
         for (int i = 0; i < 3; i++)
             vertices[i].rotX(angle);
     }
     public void rotZ(double angle) {
         for (int i = 0; i < 3; i++)
             vertices[i].rotZ(angle);
     }
}
