/*
 * Vector3D.java
 *
 * Created on 1. Mrz 2007, 16:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Engine;

/**
 *
 * @author Sunshine
 */
public class Vector3D {

    public double x, y, z;

    /** Creates a new instance of Vector3D */
    public Vector3D() {
        x = y = z = 0.0;
    }

    public Vector3D(double x, double y, double z)
    {
        this.x = x;
        this.y = y;
        this.z = z;
    }

    public void add(double offset)
    {
        this.x += offset;
        this.y += offset;
        this.z += offset;
    }

    public void add(double x, double y, double z)
    {
        this.x += x;
        this.y += y;
        this.z += z;
    }

    public void add(Vector3D v)
    {
        this.x += v.x;
        this.y += v.y;
        this.z += v.z;
    }

    public void sub(Vector3D v)
    {
         this.x -= v.x;
        this.y -= v.y;
        this.z -= v.z;
    }


    public void rotX(double angle)
    {
        double yOri = y;
        y = y * Math.cos(angle) - z * Math.sin(angle);
        z = yOri * Math.sin(angle) + z * Math.cos(angle);
    }

    public void rotY(double angle)
    {
        double xOri = x;
        x = x * Math.cos(angle) + z * Math.sin(angle);
        z = xOri * -Math.sin(angle) + z * Math.cos(angle);
    }

    public void rotZ(double angle)
    {
        double xOri = x;
        x = x * Math.cos(angle) + y * -Math.sin(angle);
        y = xOri * Math.sin(angle) + y * Math.cos(angle);
    }
}
