/*
 * SkyScraper.java
 *
 * Created on 27. September 2007, 11:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import Engine.*;
import Engine.Primitives.PrimitiveInterface;
import Engine.Primitives.Quad;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
/**
 *
 * @author Sunshine
 */
public class SkyScraper implements PrimitiveInterface {
    
    public static Vector3D worldPos;
    
    public Quad front;
    public Quad left;
    public Quad right;
    public Quad back;
    
    Color color;
    
    /** Creates a new instance of SkyScraper */
    public SkyScraper() {
        worldPos = new Vector3D(0,-100,0);
        front = new Quad(   new Vector3D(-100, 0, -100),
                            new Vector3D(-75, 0, -100),
                            new Vector3D(-75, 50, -100),
                            new Vector3D(-100, 50, -100) );
        
        left = new Quad(   new Vector3D(-100, 0, -75),
                            new Vector3D(-100, 0, -100),
                            new Vector3D(-100, 50, -100),
                            new Vector3D(-100, 50, -75) );
        
        right = new Quad(   new Vector3D(-75, 0, -100),
                            new Vector3D(-75, 0, -75),
                            new Vector3D(-75, 50, -75),
                            new Vector3D(-75, 50, -100) );
        
        back = new Quad(   new Vector3D(-100, 0, -75),
                            new Vector3D(-75, 0, -75),
                            new Vector3D(-75, 50, -75),
                            new Vector3D(-100, 50, -75) );
    }
    
    public SkyScraper(Quad f, Quad l, Quad r, Quad b, int height, int n)
    {
        worldPos = new Vector3D(0,-100,0);
        front = f;
        left = l;
        right = r;
        back = b;
        // calc color
        int tmp = 255 / n * height;
        if (height == 0)
            color = new Color(0,0,0);
        else 
            color = new Color(tmp/2, 255- tmp, 255 - tmp);
    }

    public void render(Graphics g, Point[] screenCoords) {
        /*
        front.renderSolid(g, screenCoords, 0, color);
        left.renderSolid(g, screenCoords,4, color);
        right.renderSolid(g, screenCoords,8, color);
        back.renderSolid(g, screenCoords,12, color);
         **/
        front.render(g, screenCoords, 0, color);
        left.render(g, screenCoords,4,color);
        right.render(g, screenCoords,8,color);
        back.render(g, screenCoords,12,color);
    }

    public Vector3D getWorldPos() { return worldPos;    }

    public int getNumOfVertices() { return 4*4;    }

    public Vector3D[] getVertices() { 
        Vector3D[] vecs = new Vector3D[getNumOfVertices()];
        for (int i = 0; i < 4; i++)
        {
            vecs[i] = front.vertices[i];
            vecs[4+i] = left.vertices[i];
            vecs[8+i] = right.vertices[i];
            vecs[12+i] = back.vertices[i];
        }
        return vecs;
    }
    
    public void rotY(double angle)
    {
        for (int i = 0; i < 4; i++)
        {
            front.vertices[i].rotY(angle);
            left.vertices[i].rotY(angle);
            right.vertices[i].rotY(angle);
            back.vertices[i].rotY(angle);
        }
    }
    
    public void rotX(double angle)
    {
        for (int i = 0; i < 4; i++)
        {
            front.vertices[i].rotX(angle);
            left.vertices[i].rotX(angle);
            right.vertices[i].rotX(angle);
            back.vertices[i].rotX(angle);
        }
    }
    
}
